package routes_test

import (
	"fmt"
	"net/http"
)

type BadResponseWriter struct {
	Code   int
	header http.Header
}

func NewBadWriter() *BadResponseWriter {
	return &BadResponseWriter{
		header: http.Header{},
	}
}

func (w *BadResponseWriter) Header() http.Header {
	return w.header
}

func (w *BadResponseWriter) Write(b []byte) (int, error) {
	return 0, fmt.Errorf("always an error")
}

func (w *BadResponseWriter) WriteHeader(statusCode int) {
	w.Code = statusCode
}
